/*
 *  Licensed to the Apache Software Foundation (ASF) under one
 *  or more contributor license agreements.  See the NOTICE file
 *  distributed with this work for additional information
 *  regarding copyright ownership.  The ASF licenses this file
 *  to you under the Apache License, Version 2.0 (the
 *  "License"); you may not use this file except in compliance
 *  with the License.  You may obtain a copy of the License at
 * 
 *  http://www.apache.org/licenses/LICENSE-2.0
 * 
 *  Unless required by applicable law or agreed to in writing,
 *  software distributed under the License is distributed on an
 *  "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 *  KIND, either express or implied.  See the License for the
 *  specific language governing permissions and limitations
 *  under the License.
 */
package org.apache.myfaces.commons.converter;

import javax.faces.el.ValueBinding;
import javax.faces.context.FacesContext;
import java.util.Locale;


// Generated from class org.apache.myfaces.commons.converter.AbstractTypedNumberConverter.
//
// WARNING: This file was automatically generated. Do not edit it directly,
//          or you will lose your changes.
public class TypedNumberConverter extends org.apache.myfaces.commons.converter.AbstractTypedNumberConverter
{

    static public final String CONVERTER_ID = 
        "org.apache.myfaces.custom.convertNumber.TypedNumberConverter";

    public TypedNumberConverter()
    {
    }


    // Property: groupingUsed
    private boolean _groupingUsed;
    
    private boolean _groupingUsedSet;
    
    public boolean isGroupingUsed()
    {
        if (_groupingUsedSet)
        {
            return _groupingUsed;
        }
        ValueBinding vb = getValueBinding("groupingUsed");
        if (vb != null)
        {
            return ((Boolean) vb.getValue(getFacesContext())).booleanValue();
        }
        return true; 
    }

    public void setGroupingUsed(boolean groupingUsed)
    {
        this._groupingUsed = groupingUsed;
        this._groupingUsedSet = true;        
    }

    // Property: integerOnly
    private boolean _integerOnly;
    
    private boolean _integerOnlySet;
    
    public boolean isIntegerOnly()
    {
        if (_integerOnlySet)
        {
            return _integerOnly;
        }
        ValueBinding vb = getValueBinding("integerOnly");
        if (vb != null)
        {
            return ((Boolean) vb.getValue(getFacesContext())).booleanValue();
        }
        return false; 
    }

    public void setIntegerOnly(boolean integerOnly)
    {
        this._integerOnly = integerOnly;
        this._integerOnlySet = true;        
    }

    // Property: maxFractionDigits
    private Integer _maxFractionDigits;
    
    public Integer getMaxFractionDigits()
    {
        if (_maxFractionDigits != null)
        {
            return _maxFractionDigits;
        }
        ValueBinding vb = getValueBinding("maxFractionDigits");
        if (vb != null)
        {
            Object value = vb == null ? null : vb.getValue(getFacesContext());
            if (!(value instanceof Integer)){
                value = Integer.valueOf(value.toString());
            }            
            return (Integer) value;
        }
        return null;
    }

    public void setMaxFractionDigits(Integer maxFractionDigits)
    {
        this._maxFractionDigits = maxFractionDigits;
    }

    // Property: maxIntegerDigits
    private Integer _maxIntegerDigits;
    
    public Integer getMaxIntegerDigits()
    {
        if (_maxIntegerDigits != null)
        {
            return _maxIntegerDigits;
        }
        ValueBinding vb = getValueBinding("maxIntegerDigits");
        if (vb != null)
        {
            Object value = vb == null ? null : vb.getValue(getFacesContext());
            if (!(value instanceof Integer)){
                value = Integer.valueOf(value.toString());
            }            
            return (Integer) value;
        }
        return null;
    }

    public void setMaxIntegerDigits(Integer maxIntegerDigits)
    {
        this._maxIntegerDigits = maxIntegerDigits;
    }

    // Property: minFractionDigits
    private Integer _minFractionDigits;
    
    public Integer getMinFractionDigits()
    {
        if (_minFractionDigits != null)
        {
            return _minFractionDigits;
        }
        ValueBinding vb = getValueBinding("minFractionDigits");
        if (vb != null)
        {
            Object value = vb == null ? null : vb.getValue(getFacesContext());
            if (!(value instanceof Integer)){
                value = Integer.valueOf(value.toString());
            }            
            return (Integer) value;
        }
        return null;
    }

    public void setMinFractionDigits(Integer minFractionDigits)
    {
        this._minFractionDigits = minFractionDigits;
    }

    // Property: minIntegerDigits
    private Integer _minIntegerDigits;
    
    public Integer getMinIntegerDigits()
    {
        if (_minIntegerDigits != null)
        {
            return _minIntegerDigits;
        }
        ValueBinding vb = getValueBinding("minIntegerDigits");
        if (vb != null)
        {
            Object value = vb == null ? null : vb.getValue(getFacesContext());
            if (!(value instanceof Integer)){
                value = Integer.valueOf(value.toString());
            }            
            return (Integer) value;
        }
        return null;
    }

    public void setMinIntegerDigits(Integer minIntegerDigits)
    {
        this._minIntegerDigits = minIntegerDigits;
    }

    // Property: pattern
    private String _pattern;
    
    public String getPattern()
    {
        if (_pattern != null)
        {
            return _pattern;
        }
        ValueBinding vb = getValueBinding("pattern");
        if (vb != null)
        {
            return (String) vb.getValue(getFacesContext());
        }
        return null;
    }

    public void setPattern(String pattern)
    {
        this._pattern = pattern;
    }

    // Property: type
    private String _type;
    
    public String getType()
    {
        if (_type != null)
        {
            return _type;
        }
        ValueBinding vb = getValueBinding("type");
        if (vb != null)
        {
            return (String) vb.getValue(getFacesContext());
        }
        return "number"; 
    }

    public void setType(String type)
    {
        this._type = type;
    }


    public Object saveState(FacesContext facesContext)
    {
        Object[] values = new Object[11];
        values[0] = super.saveState(facesContext);
        values[1] = Boolean.valueOf(_groupingUsed);
        values[2] = Boolean.valueOf(_groupingUsedSet);
        values[3] = Boolean.valueOf(_integerOnly);
        values[4] = Boolean.valueOf(_integerOnlySet);
        values[5] = _maxFractionDigits;
        values[6] = _maxIntegerDigits;
        values[7] = _minFractionDigits;
        values[8] = _minIntegerDigits;
        values[9] = _pattern;
        values[10] = _type;
        return values; 
    }

    public void restoreState(FacesContext facesContext, Object state)
    {
        Object[] values = (Object[])state;
        super.restoreState(facesContext,values[0]);
        _groupingUsed = ((Boolean) values[1]).booleanValue();
        _groupingUsedSet = ((Boolean) values[2]).booleanValue();
        _integerOnly = ((Boolean) values[3]).booleanValue();
        _integerOnlySet = ((Boolean) values[4]).booleanValue();
        _maxFractionDigits = (java.lang.Integer) values[5];
        _maxIntegerDigits = (java.lang.Integer) values[6];
        _minFractionDigits = (java.lang.Integer) values[7];
        _minIntegerDigits = (java.lang.Integer) values[8];
        _pattern = (java.lang.String) values[9];
        _type = (java.lang.String) values[10];
    }
}
